/*

  trace.h
  
  Dbugger
  
*/

#ifndef __TRACE_H
#define __TRACE_H


#include "pcode.h"

typedef
  struct {
    FUNCTION *func;
    PCODE *addr;
    PCODE value;
    }
  TRACE_BREAK;

enum
{
  TC_NONE     = 0,
  TC_STEP     = 1,
  TC_NEXT     = 2,
  TC_GO       = 3,
  TC_RETURN   = 4
};


#ifndef __TRACE_C

EXTERN FUNCTION *TRACE_start_function;

#endif


#define TRACE_WELCOME \
  "Welcome to the Gambas Debugger.\n"

PUBLIC ushort TRACE_get_current_line(void);
PUBLIC void TRACE_breakpoint(int num);
PUBLIC void TRACE_next(void);
PUBLIC void TRACE_function(void);
PUBLIC void TRACE_main(void);

#endif /* */
